/* 
   hdcod - a Hangul mail decoder
  ===============================

   This program "hdcod" is personal purpose program, I programmed this just 
   for endingless curiosity about "Hangul Coding". But I din't understand
   the behinds for "Hangul Code". I think this is a today's issue for our
   Korean internet world must be solved emergently. I don't know much about
   computer and its coding method. Moreover I didn't understand Korean 
   language structure..
      You can copy and use this as you like. but I don't think you could 
   use this program to any commercial purpose.. 
    
   The belows are note for myself.. - You even more shouldn't trust me!
   
      QP decoding and main body - Park Myeong Seok(1995. 5. 1)
      B64toKS routine - Ienup Sung(1992. 7. 22) : GPL Copying Policy  
      ISOtoKS routine - June-Yub Lee(1992. 2. 29)

   Note: This program doesn't require any character set infomations. 
         Strictly speaking, a mail implies one of coding infomations
         in mail header or contents - this is the basic idea for this 
         freeware. This does not means "hdcod" usies mail header info. 
         such as "Quoted Printable" for QP, contents character set 
         "iso-2022-kr" for ISO. It looks sequential characters and
         jurdges what is the encoded method.. Thus, it can correctly
         decode for one of the above three encoding methods. 
            The name is similar to wellknown "hcode" because of its 
         similar usages, but you can find the differneces. But, this 
         decoding method cannot be generalized. Only useful for encoded 
         Hangul + English email.

   Usage: hdcod <coded QP or ISO or Base64 email> <new KS output>
        
         If QP or ISO or B64 Korean mail is given, it automatically
         converts to KS code.

   - pms@romance.kaist.ac.kr
*/

#include <string.h>
#include <stdio.h>
#include <ctype.h>

static char *HelpText[] = {
    "\nhdcod: Decodes QP or ISO or B64 Hangul email to KS code.\n",
    "  (QP: Quoted Printable, ISO: ISO-2022-KR, B64: Base64(EUC-KR),",
    " KS: KSC-5601)\n",
    "       - pms@romance.kaist.ac.kr(1995. 5. 1)\n",
    "Usage: hdcod <coded QP/ISO/B64 Hangul email> <KS output>\n\n",
    ""
};

void HelpMsg(void)
{
    char **m = HelpText;
    while(**m) printf(*m++);
}

int QPtoKS(char *s)
{
    register i, hcode, byte;
    
    for(i=0; i<2; i++) {
        byte = (s[i] > 0x2F && s[i] < 0x3A)? s[i] - 0x30:
               (s[i] > 0x40 && s[i] < 0x47)? s[i] - 0x37:
               (s[i] > 0x60 && s[i] < 0x67)? s[i] - 0x57:
               -1;
        if(byte<0) return 0x00;
        hcode = (i==0)? byte << 4: hcode + byte; 
    }
    return hcode;
}

void B64toKS(char *ob, char *ib)
{
    register unsigned long bm=0;
    register short cnt=0;

    for(; *ib!=0x00; ib++) {
        bm = (*ib==0x2B)?  (bm << 6) | 0x3E:
             (*ib==0x2F)?  (bm << 6) | 0x3F:
             isdigit(*ib)? (bm << 6) | (0x34 + *ib - 0x30):
             isupper(*ib)? (bm << 6) | (*ib - 0x41):
             islower(*ib)? (bm << 6) | (0x1A + *ib - 0x61):
             (bm << 6) | 0;
        if(++cnt >= 4) {
            *ob++ = (char)((bm & 0x0FF0000) >> 16);
            *ob++ = (char)((bm & 0x000FF00) >> 8);
            *ob++ = (char) (bm & 0x00000FF);
            cnt = bm = 0;
        }
    }
    *ob = 0x00;
}

int main(char ac, char **av)
{
    FILE     *in, *out;
    char     ch, hs[3];
    static   char rb[255], ob[255];
    register i, ISO=0, KOR=0, B64=0, WHT=0;

    if(ac != 3) { HelpMsg(); return 0; }
    if((in=fopen(av[1], "r")) == NULL)  { perror(av[1]); return 0; }
    if((out=fopen(av[2], "w")) == NULL) { perror(av[2]); return 0; }

    while((ch=fgetc(in)) != EOF) {
        if(ch == 0x1B) {                  /* If ISO-2022-KR encoded Korean.. */
            if((ch=fgetc(in)) == 0x24) 
                if((ch=fgetc(in)) == 0x29) 
                    if((ch=fgetc(in)) == 0x43) { ISO = 1; continue; }
        } 
        if(ch==0x0E || ch==0x0F) {        /* Modify This !! */
       	    ISO = 1;                      /* ISO flag must be considered ! */
       	    KOR = (ch==0x0E)? 1: 0;       /* I ignored ISO flag !*/
       	    if(!KOR) ISO = 0;
       	    continue; 
        } 
        if(KOR) {
            if(ch==0x20 || ch==0x09 || ch==0x0A) fputc(ch, out);
            else fputc(ch + 0x80, out);
        }
        else if(ch == 0x3D) { 
            if((ch=fgetc(in)) == 0x3F) {  /* If Base64 encoded Korean.. */
                for(rb[0]=ch, i=1; i<10; i++) rb[i] = fgetc(in);
                rb[i] = 0x00;
                if(!strcmp(rb,"?B?EUC-KR?")||!strcmp(rb,"?EUC-KR?B?")) {
                    for(B64=1, rb[0]=0x00, i=0; B64;) {
                        if((ch=fgetc(in)) == 0x3F) {
                            ob[i++] = ch;
                            if((ch=fgetc(in)) == 0x3D) {
                                B64 = 0; ob[--i] = 0x00;
                                break;
                            }
                        }
                        ob[i++] = ch;  
                    }
                    B64toKS(rb, ob);
                }
                for(i=0; rb[i]!=0x00; i++) fputc(rb[i], out);
                rb[0] = ob[0] = 0x00;
            }    
            else {                        /* If QP encoded Korean.. */
                if(ch==0x20 || ch==0x09 || ch==0x0A) { WHT=1; continue; }
                WHT = 0; hs[0] = ch; hs[1] = fgetc(in); hs[2] = 0x00;
                if((ch=QPtoKS(hs)) == 0x00) {
                    fputc(0x3D, out);
                    for(i=0; i<2; i++) fputc(hs[i], out);
                }
                else fputc(ch, out);
            }
        }
        else fputc(ch, out);              /* Else this is English.. */
    }
    if(WHT) fputc(0x3D, out);             /* Some dirty condition.. */
    fclose(in); fclose(out);
    return 0;
}
